#ifndef CKCoreAVAsset_h
#define CKCoreAVAsset_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

#import <AVFoundation/AVFoundation.h>

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAVAsset: NSObject

+ (NSUInteger) numberOfAudioTracks:(NSURL *) withUrl;
+ (NSUInteger) numberOfVideoTracks:(NSURL *) withUrl;
+ (NSUInteger) numberOfAudioTracksFromAsset:(AVURLAsset *) withAsset;
+ (NSUInteger) numberOfVideoTracksFromAsset:(AVURLAsset *) withAsset;
+ (CGFloat)    durationOfTracks:(NSURL *) withUrl;
+ (NSUInteger) durationOfTracksFromAsset:(AVURLAsset *) withAsset;

@end

#endif

