#ifndef CKCoreCGUtilities_h
#define CKCoreCGUtilities_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

@class CKCoreCGUtilities;

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreCGUtilities: NSObject

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreCGUtilities (CGPoint)

+ (CGPoint)    CGPointScale:(CGPoint) withPoint withRatioX:(CGFloat) withRatioX withRatioY:(CGFloat) withRatioY;
+ (CGPoint)    CGPointScale:(CGPoint) withPoint withRatio:(CGSize) withRatio;
+ (CGPoint)    CGPointSubstract:(CGPoint) withPoint1 withPoint2:(CGPoint) withPoint2;
+ (NSString *) CGPointToString:(CGPoint) withPoint;
+ (CGPoint)    stringToCGPoint:(NSString *) withString;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreCGUtilities (CGRect)

+ (CGRect)       CGRectAddY:(CGRect) withRect withOffset:(CGFloat) withOffset;
+ (CGRect)       CGRectAddWidth:(CGRect) withRect withOffset:(CGFloat) withOffset;
+ (CGRect)       CGRectScale:(CGRect) withRect withRatioX:(CGFloat) withRatioX withRatioY:(CGFloat) withRatioY;
+ (CGRect)       CGRectScale:(CGRect) withRect withRatio:(CGSize) withRatio;
+ (NSEdgeInsets) NSEdgeInsetsScale:(NSEdgeInsets) withRect withRatio:(CGSize) withRatio;
+ (NSString *)   CGRectToString:(CGRect) withSize;
+ (CGRect)       stringToCGRect:(NSString *) withString;
+ (CGRect)       CGSizeFitToRect:(CGSize) withSize fitInRect:(CGRect) fitInRect;
+ (CGRect)       CGRectScaleToWidth:(CGRect) withRect withWidth:(CGFloat) withWidth;
+ (CGRect)       CGRectScaleToHeight:(CGRect) withRect withHeight:(CGFloat) withHeight;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreCGUtilities (CGSize)

+ (CGSize)     CGSizeAddHeight:(CGSize) withSize withHeight:(CGFloat) withHeight;
+ (CGSize)     CGSizeScale:(CGSize) withSize withRatioX:(CGFloat) withRatioX withRatioY:(CGFloat) withRatioY;
+ (CGSize)     CGSizeScale:(CGSize) withSize withRatio:(CGSize) withRatio;
+ (CGSize)     CGSizeScale:(CGSize) withSize withPercent:(CGFloat) withPercent;
+ (CGSize)     CGSizeSwap:(CGSize) withSize;
+ (CGSize)     CGSizeFitToWidth:(CGSize) withSize withWidth:(CGFloat) withWidth;
+ (CGSize)     CGSizeFitToHeight:(CGSize) withSize withHeight:(CGFloat) withHeight;
+ (NSString *) CGSizeToString:(CGSize) withSize;
+ (CGSize)     stringToCGSize:(NSString *) withString;
+ (CGSize)     CGSizeMutiply:(CGSize) withSize withMultiplier:(CGFloat) withMultiplier;
+ (CGSize)     CGSizeFitToSize:(CGSize) withSize fitInSize:(CGSize) fitInSize;
+ (CGSize)     CGSizeFillToSize:(CGSize) withSize fillInSize:(CGSize) fillInSize;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreCGUtilities (CGFloat)

+ (CGFloat) CGFloatArrayMaxValueIndex:(NSArray *) withArray;

@end

#endif

