#ifndef CKCoreCameraRecord_h
#define CKCoreCameraRecord_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreCameraRecord: NSObject

- (Boolean)        startRecording:(NSURL *) toUrl fps:(CGFloat) fps recordingDuration:(NSTimeInterval) recordingDuration recordingPreset:(AVCaptureSessionPreset) recordingPreset enableAudio:(Boolean) enableAudio completionBlock:(void (^)(Boolean isSuccess)) completionBlock;
- (void)           stopCamera;
- (Boolean)        startCamera:(AVCaptureDevice *) withDevice;
- (void)           pauseRecording;
- (void)           resumeRecording;
- (Boolean)        isRecording;
- (void)           stopRecording;
- (NSTimeInterval) recordedDuration;

@end

#endif

