#ifndef CKCoreLabel_h
#define CKCoreLabel_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSInteger, eCKCoreLabelVerticalAlignment)
  {
  CKCoreLabelVerticalAlignmentBottom,
  CKCoreLabelVerticalAlignmentCenter,
  CKCoreLabelVerticalAlignmentTop
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
IB_DESIGNABLE @interface CKCoreLabel : NSView

@property(nonatomic, copy)   IBInspectable NSString           *text;
@property(nonatomic, copy)                 NSAttributedString *attributedText;
@property(nonatomic, retain)               NSFont             *font;
@property(nonatomic, assign) IBInspectable NSInteger           fontSize;
@property(nonatomic, retain) IBInspectable NSColor            *textColor;
@property(nonatomic, retain) IBInspectable NSColor            *backgroundColor;
@property(nonatomic, assign) IBInspectable NSInteger           numberOfLines;
@property(nonatomic, assign) IBInspectable NSTextAlignment     textAlignment;
@property(nonatomic, assign) eCKCoreLabelVerticalAlignment     textVerticalAlignment;
@property(nonatomic, assign)               NSLineBreakMode     lineBreakMode;
@property(nonatomic, assign) IBInspectable CGFloat             preferredMaxLayoutWidth;

- (instancetype) init;
- (instancetype) initWithFrame:(NSRect) frameRect NS_DESIGNATED_INITIALIZER;
- (instancetype) initWithCoder:(NSCoder *) coder NS_DESIGNATED_INITIALIZER;

@end

#endif

