#ifndef CKCoreLinearProgress_h
#define CKCoreLinearProgress_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
IB_DESIGNABLE @interface CKCoreLinearProgress : NSView

@property (nonatomic) NSArray <NSColor *>  *gradientBackground;
@property (nonatomic) NSArray <NSColor *>  *gradientForeground;
@property (nonatomic) NSArray <NSNumber *> *gradientBackgroundLocations;
@property (nonatomic) NSArray <NSNumber *> *gradientForegroundLocations;
@property (nonatomic) CGFloat               gradientBackgroundAngle;
@property (nonatomic) CGFloat               gradientForegroundAngle;
@property (nonatomic) CGFloat               cornersRadius;
@property (nonatomic) CGFloat               currentProgressValue;
@property (nonatomic) CGFloat               maxProgressValue;
@property (nonatomic) Boolean               animateProgress;
@property (nonatomic) NSColor              *borderColor;
@property (nonatomic) CGFloat               borderWidth;

@end

#endif

