#ifndef CKCoreNumpy2DArray_h
#define CKCoreNumpy2DArray_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNumpy2DArray : NSObject

@property (nonatomic) UInt16             *uint16Data;
@property (nonatomic) UInt32             *uint32Data;
@property (nonatomic) Float32            *float32Data;
@property (nonatomic) Float64            *float64Data;
@property (nonatomic) NSInteger           rows;
@property (nonatomic) NSInteger           cols;

- (Boolean) load2DArrayFromFile:(NSString *) withFilePath;
- (Float32) float32Value:(int) row col:(int) col;
- (Float64) float64Value:(int) row col:(int) col;

@end

#endif

