#ifndef CKCoreSettingsStorage_h
#define CKCoreSettingsStorage_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

@class CKCoreUSERSettings;
@class CKCoreAPPSettings;

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreSettingsStorage

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAPPSettings: NSObject

+ (void)             deleteObject:(NSString *) keyName;
+ (void)             setBool:(BOOL) Value forKey:(NSString *) keyName;
+ (BOOL)             boolForKeyname:(NSString *) keyName withDefault:(BOOL) withDefault;
+ (void)             setString:(NSString *) value forKey:(NSString *) keyName;
+ (NSString *)       stringForKeyname:(NSString *) keyName withDefault:(NSString *) withDefault;
+ (void)             setInteger:(NSInteger) value forKey:(NSString *) keyName;
+ (NSInteger)        integerForKeyname:(NSString *) keyName withDefault:(NSInteger) withDefault;
+ (void)             setCGPoint:(CGPoint) value forKey:(NSString *) keyName;
+ (CGPoint)          CGPointForKeyname:(NSString *) keyName withDefault:(CGPoint) withDefault;
+ (void)             setDouble:(double) value forKey:(NSString *) keyName;
+ (double)           doubleForKeyname:(NSString *) keyName withDefault:(double) withDefault;
+ (void)             setDictionary:(NSDictionary *) value forKey:(NSString *) keyName;
+ (NSDictionary *)   dictionaryForKeyname:(NSString *) keyName withDefault:(NSDictionary *) withDefault;
+ (void)             setArray:(NSArray *) value forKey:(NSString *) keyName;
+ (NSMutableArray *) arrayForKeyname:(NSString *) keyName withDefault:(NSArray *) withDefault;
+ (void)             setCGSize:(CGSize) value forKey:(NSString *) keyName;
+ (CGSize)           CGSizeForKeyname:(NSString *) keyName withDefault:(CGSize) withDefault;
+ (void)             setData:(NSData *) value forKey:(NSString *) keyName;
+ (NSMutableData *)  dataForKeyname:(NSString *) keyName withDefault:(NSData *) withDefault;
+ (void)             setCGRect:(CGRect) value forKey:(NSString *) keyName;
+ (CGRect)           CGRectForKeyname:(NSString *) keyName withDefault:(CGRect) withDefault;
+ (void)             setDate:(NSDate *) value forKey:(NSString *) keyName;
+ (NSDate *)         dateForKeyname:(NSString *) keyName withDefault:(NSDate *) DefaultValue;
+ (void)             setFloat:(CGFloat) value forKey:(NSString *) keyName;
+ (CGFloat)          floatForKeyname:(NSString *) keyName withDefault:(CGFloat) DefaultValue;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreUSERSettings: NSObject

+ (void)             deleteObject:(NSString *) withFolder keyName:(NSString *) keyName;
+ (void)             setBool:(NSString *) withFolder value:(BOOL) value forKey:(NSString *) keyName;
+ (BOOL)             boolForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(BOOL) withDefault;
+ (void)             setString:(NSString *) withFolder value:(NSString *) value forKey:(NSString *) keyName;
+ (NSString *)       stringForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(NSString *) withDefault;
+ (void)             setInteger:(NSString *) withFolder value:(NSInteger) value forKey:(NSString *) keyName;
+ (NSInteger)        integerForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(NSInteger) withDefault;
+ (void)             setCGPoint:(NSString *) withFolder value:(CGPoint) value forKey:(NSString *) keyName;
+ (CGPoint)          CGPointForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(CGPoint) withDefault;
+ (void)             setDouble:(NSString *) withFolder value:(double) value forKey:(NSString *) keyName;
+ (double)           doubleForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(double) withDefault;
+ (void)             setDictionary:(NSString *) withFolder value:(NSDictionary *) value forKey:(NSString *) keyName;
+ (NSDictionary *)   dictionaryForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(NSDictionary *) withDefault;
+ (void)             setArray:(NSString *) withFolder value:(NSArray *) value forKey:(NSString *) keyName;
+ (NSMutableArray *) arrayForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(NSArray *) withDefault;
+ (void)             setCGSize:(NSString *) withFolder value:(CGSize) value forKey:(NSString *) keyName;
+ (CGSize)           CGSizeForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(CGSize) withDefault;
+ (void)             setData:(NSString *) withFolder value:(NSData *) value forKey:(NSString *) keyName;
+ (NSMutableData *)  dataForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(NSData *) withDefault;
+ (void)             setCGRect:(NSString *) withFolder value:(CGRect) value forKey:(NSString *) keyName;
+ (CGRect)           CGRectForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(CGRect) withDefault;
+ (void)             setDate:(NSString *) withFolder value:(NSDate *) value forKey:(NSString *) keyName;
+ (NSDate *)         dateForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(NSDate *) DefaultValue;
+ (void)             setFloat:(NSString *) withFolder value:(CGFloat) value forKey:(NSString *) keyName;
+ (CGFloat)          floatForKeyname:(NSString *) withFolder keyName:(NSString *) keyName withDefault:(CGFloat) DefaultValue;

@end

#endif

