#ifndef CKCoreTimer_h
#define CKCoreTimer_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

@class CKCoreTimer;

typedef void (^CKCoreTimerHandler)(CKCoreTimer *timer);

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreTimer : NSObject

- (id)      initWithTimeIntervalSinceNow:(NSTimeInterval) delay tolorance:(double) tolerance queue:(dispatch_queue_t) queue block:(CKCoreTimerHandler) block;
- (void)    start;
- (void)    cancel;
- (Boolean) isValid;

+ (void) executeMainThreadAfter:(NSTimeInterval) delay processBlock:(void (^)(void)) processBlock;
+ (void) executeBackThreadAfter:(NSTimeInterval) delay processBlock:(void (^)(void)) processBlock;

@end

#endif

