#ifndef CKCoreTouchID_h
#define CKCoreTouchID_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

#import <LocalAuthentication/LocalAuthentication.h>

typedef NS_ENUM(NSInteger, CKCoreTouchIDErrorCode)
  {
	CKCoreTouchIDSuccess                    = 0,
  CKCoreTouchIDErrorAuthenticationFailed  = LAErrorAuthenticationFailed,
  CKCoreTouchIDErrorUserCancel            = LAErrorUserCancel,
  CKCoreTouchIDErrorUserFallback          = LAErrorUserFallback,
  CKCoreTouchIDErrorTouchIDNotEnrolled    = LAErrorBiometryNotEnrolled,
  CKCoreTouchIDErrorTouchIDLockout        = LAErrorBiometryLockout,
  CKCoreTouchIDErrorAppCancel             = LAErrorAppCancel,
  CKCoreTouchIDErrorInvalidContext        = LAErrorInvalidContext,
  CKCoreTouchIDErrorNotImplemented        = -9999,
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreTouchID : NSObject

- (void)    authenticate:(id) parent message:(NSString *) message onAuthenticateDone:(SEL) onAuthenticateDone;
+ (Boolean) isTouchIDAvailable;

@end

#endif

