#ifndef CKCoreViewAnimation_h
#define CKCoreViewAnimation_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

NS_ASSUME_NONNULL_BEGIN

//----------------------------------------------------------------------------------------------------
typedef NS_ENUM(NSInteger, ViewShakeDirection)
  {
  ViewShakeDirectionHorizontal,
  ViewShakeDirectionVertical
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreViewAnimation: NSObject

+ (void) enlargeAndBack:(NSView *) withView withDuration:(NSTimeInterval) withDuration withScaleFactor:(CGFloat) withScaleFactor completionBlock:(void (^)(void)) completionBlock;

+ (void) shake:(NSView *) withView;
+ (void) shake:(NSView *) withView times:(int) times withDelta:(CGFloat) delta;
+ (void) shake:(NSView *) withView times:(int) times withDelta:(CGFloat) delta completion:(nullable void (^)(void)) handler;
+ (void) shake:(NSView *) withView times:(int) times withDelta:(CGFloat) delta speed:(NSTimeInterval) interval;
+ (void) shake:(NSView *) withView times:(int) times withDelta:(CGFloat) delta speed:(NSTimeInterval) interval completion:(nullable void (^)(void)) handler;
+ (void) shake:(NSView *) withView times:(int) times withDelta:(CGFloat) delta speed:(NSTimeInterval) interval shakeDirection:(ViewShakeDirection) shakeDirection;
+ (void) shake:(NSView *) withView times:(int) times withDelta:(CGFloat) delta speed:(NSTimeInterval) interval shakeDirection:(ViewShakeDirection) shakeDirection completion:(nullable void (^)(void)) handler;
+ (void) shake:(NSView *) withView times:(int) times direction:(int) direction currentTimes:(int) current withDelta:(CGFloat) delta speed:(NSTimeInterval) interval shakeDirection:(ViewShakeDirection) shakeDirection completion:(nullable void (^)(void)) handler;

@end

NS_ASSUME_NONNULL_END

#endif
