#ifndef CKCorevDSP_h
#define CKCorevDSP_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCorevDSP: NSObject

+ (Float32)   sumValueInFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (Float32)   maxValueInFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (Float32 *) add2FloatArrays:(Float32 *) withArray1 withArray2:(Float32 *) withArray2 withArrayCount:(NSInteger) withArrayCount;
+ (Float32 *) divideFloatArrayBy:(Float32 *) withArray withDivider:(Float32) withDivider withArrayCount:(NSInteger) withArrayCount;
+ (Float32 *) absFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (void)      swap2FloatArrays:(Float32 *) withArray1 withArray2:(Float32 *) withArray2 withArrayCount:(NSInteger) withArrayCount;
+ (void)      reverseFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (void)      sortFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount isAscending:(Boolean) isAscending;
+ (void)      fillFloatArray:(Float32 *) withArray withValue:(Float32) withValue withArrayCount:(NSInteger) withArrayCount;
+ (Float32 *) fractionalPartFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (Float32 *) addFloatArrayBy:(Float32 *) withArray withAddition:(Float32) withAddition withArrayCount:(NSInteger) withArrayCount;
+ (Float32)   meanValueInFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (Float32)   squareMeanValueInFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (Float32 *) multiplyFloatArrayBy:(Float32 *) withArray withMultiplier:(Float32) withMultiplier withArrayCount:(NSInteger) withArrayCount;
+ (NSInteger) maxValueIndexInFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (void)      normalizeFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (void)      normalizeFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount withCeilingValue:(Float32) withCeilingValue;
+ (CGFloat)   dBAmplitudeFromFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (CGFloat)   dBPowerFromFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount;
+ (void)      dBAvgPeakFromFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount withAverage:(float *) withAverage withPeak:(float *) withPeak;
+ (Float32 *) resizeFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withOriginalArrayCount withNewArrayCount:(NSInteger) withNewArrayCount;
+ (Float32 *) resizeFloat2DMatrix:(Float32 *) withMatrix withMatrixSize:(CGSize) withMatrixSize withNewMatrixSize:(CGSize) withNewMatrixSize;
+ (Float32 *) rescaleFloat2DMatrix:(Float32 *) withMatrix withMatrixSize:(CGSize) withMatrixSize withNewMatrixSize:(CGSize) withNewMatrixSize;
+ (Float32 *) rescaleFloatArray:(Float32 *) withArray withArrayCount:(NSInteger) withArrayCount withNewArrayCount:(NSInteger) withNewArrayCount;

@end

#endif

