#ifndef CKCoreAudioRMSLevels_h
#define CKCoreAudioRMSLevels_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

@class CKCoreAudioFile;

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAudioRMSLevels: NSObject

@property (nonatomic) CKCoreAudioFile               *audioFile;
@property (nonatomic) NSURL                         *audioFileUrl;
@property (nonatomic) NSTimeInterval                 audioMaxDuration;
@property (nonatomic) Boolean                        audioNormalize;
@property (nonatomic) float                         *volumeMap;
@property (nonatomic, readonly) NSInteger            volumeMapSize;

- (void) calculateVolumeMap:(CGFloat) withMsWindow;
- (void) cleanUp;

@end

#endif

