#ifndef CKCoreCreditCardValidator_h
#define CKCoreCreditCardValidator_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSInteger, CreditCardBrand)
  {
  CreditCardBrandVisa,
  CreditCardBrandMasterCard,
  CreditCardBrandDinersClub,
  CreditCardBrandAmex,
  CreditCardBrandDiscover,
  CreditCardBrandUnknown
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreCreditCardValidator : NSObject

+ (CreditCardBrand) checkCardBrandWithNumber:(NSString *) cardNumber;
+ (BOOL)            checkCreditCardNumber:(NSString *) cardNum;

@end

#endif
