#ifndef CKCoreDateTime_h
#define CKCoreDateTime_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreDateTime: NSObject

+ (NSString *)     timecodeFromTimeInterval:(NSTimeInterval) withTime withFrameRate:(CGFloat) withFrameRate;
+ (NSString *)     timecodeFromTimeInterval:(NSTimeInterval) withTime withFrameRate:(CGFloat) withFrameRate withSign:(NSString *) withSign;
+ (NSString *)     timecodeFromFrameNumber:(NSUInteger) withFrameNumber withFrameRate:(CGFloat) withFrameRate;
+ (NSString *)     timeFormattedHHMMSS:(NSTimeInterval) totalSeconds;
+ (NSString *)     timeFormattedMMSS:(NSTimeInterval) totalSeconds;
+ (NSString *)     timeFormattedHHMM:(NSDate *) withDate;
+ (NSString *)     toHHMMSS:(NSDate *) withDate;
+ (NSString *)     toISO8601:(NSDate *) withValue;
+ (NSString *)     timeFormattedHHMMSSmmm:(NSTimeInterval) withTime;
+ (NSString *)     timeFormattedHHMMSSmmm:(NSTimeInterval) withTime withSeparator:(NSString *) withSeparator;
+ (NSString *)     timeFormattedMMMDD:(NSDate *) withDate;
+ (NSString *)     timeFormattedMMSSm:(NSTimeInterval) withTime;
+ (NSString *)     timeFormattedHHMMSSmm:(NSTimeInterval) withTime;
+ (NSString *)     timeFormattedYYYYMMDDHHMMSS:(NSDate *) withDate;
+ (NSString *)     timeFormattedDDMMMYYYYHHMM:(NSDate *) withDate;
+ (NSTimeInterval) fromHHMMSSmm:(NSString *) withValue;
+ (NSTimeInterval) fromMMSS:(NSString *) withValue;
+ (NSDate *)       fromYYYYMMDDHHMMSS:(NSString *) withValue;
+ (NSTimeInterval) fromHHMMSSFF:(NSString *) withValue withFps:(CGFloat) withFps;
+ (NSDate *)       fromISO8601:(NSString *) withValue;
+ (NSInteger)      currentYear;
+ (NSInteger)      currentMonth;
+ (NSInteger)      currentDay;
+ (NSString *)     currentUnixTime;
+ (NSTimeInterval) fromHH_MM_SS_mm:(NSString *) withValue;
+ (NSTimeInterval) fromMM_SS_mmm:(NSString *) withValue;
+ (NSString *)     dateFormattedYYYYMMDD:(NSDate *) withDate;

@end

#endif

