#ifndef CKCoreElevenLabs_h
#define CKCoreElevenLabs_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef void (^CKCoreElevenLabsStreamCallback) (NSURLSessionDataTask *task, NSData *data, NSError *error);

//----------------------------------------------------------------------------------------------------
@interface CKCoreElevenLabs: NSObject

+ (void) text2SpeechToFile:(NSString *) apiKey withEngineModelID:(NSString *) withEngineModelID withVoiceModelID:(NSString *) withVoiceModelID withText:(NSString *) withText withOutputFormat:(NSString *) withOutputFormat withFileUrl:(NSURL *) withFileUrl completionBlock:(void (^)(NSError *error)) completionBlock;
+ (void) text2Speech:(NSString *) apiKey withEngineModelID:(NSString *) withEngineModelID withVoiceModelID:(NSString *) withVoiceModelID withText:(NSString *) withText withOutputFormat:(NSString *) withOutputFormat completionBlock:(void (^)(NSData *result, NSInteger statusCode, NSError *error)) completionBlock;
+ (void) text2SpeechVoices:(NSString *) apiKey completionBlock:(void (^)(NSArray <NSDictionary *> *voices, NSInteger statusCode, NSError *error)) completionBlock;

- (void) text2SpeechStream:(NSString *) apiKey withEngineModelID:(NSString *) withEngineModelID withVoiceModelID:(NSString *) withVoiceModelID withText:(NSString *) withText withOutputFormat:(NSString *) withOutputFormat completionBlock:(CKCoreElevenLabsStreamCallback) completionBlock;

@end

#define ELEVENLABS_mp3_22050_32  @"mp3_22050_32"
#define ELEVENLABS_mp3_44100_32  @"mp3_44100_32"
#define ELEVENLABS_mp3_44100_64  @"mp3_44100_64"
#define ELEVENLABS_mp3_44100_96  @"mp3_44100_96"
#define ELEVENLABS_mp3_44100_128 @"mp3_44100_128"
#define ELEVENLABS_mp3_44100_192 @"mp3_44100_192"
#define ELEVENLABS_pcm_16000     @"pcm_16000"
#define ELEVENLABS_pcm_22050     @"pcm_22050"
#define ELEVENLABS_pcm_24000     @"pcm_24000"
#define ELEVENLABS_pcm_44100     @"pcm_44100"
#define ELEVENLABS_ulaw_8000     @"ulaw_8000"

#define ELEVENLABS_eleven_monolingual_v1  @"eleven_monolingual_v1"
#define ELEVENLABS_eleven_multilingual_v1 @"eleven_multilingual_v1"
#define ELEVENLABS_eleven_multilingual_v2 @"eleven_multilingual_v2"
#define ELEVENLABS_eleven_turbo_v2        @"eleven_turbo_v2"

#endif

