#ifndef CKCoreFramework_h
#define CKCoreFramework_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

/*
![An architecture diagram showing the different services](test.png)
*/

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreFramework: NSObject

+ (NSString *) frameworkVersionShort;
+ (NSString *) frameworkVersionBuild;
+ (NSString *) frameworkVersionLong;
+ (NSString *) frameworkName;

+ (NSString *) expectedLicenseBundleID;
+ (void)       isValidLicenseInstalled:(void (^)(Boolean isSuccess)) completionBlock;
+ (void)       getLicenseStatus:(void (^)(NSInteger exitCode, NSString *message)) completionBlock;
+ (void)       setLicenseData:(NSDictionary *) withLicenseData completionBlock:(void (^)(Boolean isSuccess)) completionBlock;

@end

#endif 

