#ifndef CKCoreHiddenTextEntry_h
#define CKCoreHiddenTextEntry_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #import <CodKits_macOS/CodKits_macOS.h>
#else
  #import <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSInteger, eCKCoreHiddenTextEntryType)
  {
  CKCoreHiddenTextEntryTypeFree,
  CKCoreHiddenTextEntryTypeEmail,
  CKCoreHiddenTextEntryTypeCreditCardName,
  CKCoreHiddenTextEntryTypeCreditCardNumber,
  CKCoreHiddenTextEntryTypeBundleID,
  CKCoreHiddenTextEntryTypeNumeric,
  };

//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreHiddenTextEntry: NSView 

@property (nonatomic) id                                    delegate;
@property (nonatomic) SEL                                   onEntryUpdated;
@property (nonatomic) SEL                                   onEntryTAB;
@property (nonatomic) SEL                                   onEntryENTER;
@property (nonatomic) SEL                                   onEntryESC;
@property (nonatomic) eCKCoreHiddenTextEntryType            entryType;
@property (nonatomic) NSString                             *textValue;
@property (nonatomic) NSInteger                            textMinimumSize;
@property (nonatomic) NSInteger                            textMaximumSize;
@property (nonatomic) NSString                             *placeholder;
@property (nonatomic) NSString                             *validTextIndicator;
@property (nonatomic) NSString                             *invalidTextIndicator;
@property (nonatomic) Boolean                               enabled;
@property (nonatomic) Boolean                               disableIfNoNetwork;
@property (nonatomic) Boolean                               isValidEntry;
@property (nonatomic) NSColor                              *colorPlaceholder;
@property (nonatomic) NSColor                              *colorBorderStateEmpty;
@property (nonatomic) NSColor                              *colorBorderStateDisabled;
@property (nonatomic) NSColor                              *colorBorderStateValid;
@property (nonatomic) NSColor                              *colorBorderStateInvalid;
@property (nonatomic) NSColor                              *colorBackgroundStateDisabled;
@property (nonatomic) NSColor                              *colorBackgroundStateValid;
@property (nonatomic) NSColor                              *colorBackgroundStateInvalid;
@property (nonatomic) NSColor                              *colorTextStateDisabled;
@property (nonatomic) NSColor                              *colorTextStateValid;
@property (nonatomic) NSColor                              *colorTextStateInvalid;
@property (nonatomic) CGFloat                               cornersRadius;

- (void)       makeResponder;
- (void)       cleanUp;
- (void)       showClearText;

@end

#endif

