#ifndef CKCoreImageVision_h
#define CKCoreImageVision_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

#import <Vision/Vision.h>

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreImageVision: NSObject

+ (void)    getFeaturePrint:(NSImage *) withImage completionBlock:(void (^)(Boolean isSuccess, VNFeaturePrintObservation *feature, NSError *error)) completionBlock;
+ (CGFloat) calculateDistance:(VNFeaturePrintObservation *) imageA imageB:(VNFeaturePrintObservation *) imageB;
+ (void)    getFaces:(NSImage *) withImage completionBlock:(void (^)(Boolean isSuccess, NSArray<VNFaceObservation *> *faces, NSError *error)) completionBlock;
+ (void)    getPeople:(NSImage *) withImage upperBodyOnly:(Boolean) upperBodyOnly completionBlock:(void (^)(Boolean isSuccess, NSArray<VNHumanObservation *> *people, NSError *error)) completionBlock;
+ (void)    getAnimals:(NSImage *) withImage completionBlock:(void (^)(Boolean isSuccess, NSArray<VNRecognizedObjectObservation *> *animals, NSError *error)) completionBlock;
+ (void)    getBarcodes:(NSImage *) withImage completionBlock:(void (^)(Boolean isSuccess, NSArray<VNBarcodeObservation *> *barCodes, NSError *error)) completionBlock;
+ (void)    getAnnotations:(NSImage *) withImage reportCharacterBoxes:(Boolean) reportCharacterBoxes completionBlock:(void (^)(Boolean isSuccess, NSArray<VNTextObservation *> *annotations, NSError *error)) completionBlock;
+ (void)    getHorizon:(NSImage *) withImage completionBlock:(void (^)(Boolean isSuccess, NSArray<VNHorizonObservation *> *horizon, NSError *error)) completionBlock;
+ (void)    getForegroundObjects:(NSImage *) withImage completionBlock:(void (^)(Boolean isSuccess, NSArray<VNInstanceMaskObservation *> *masks, NSError *error)) completionBlock;
+ (void)    getAestheticsScore:(NSImage *) withImage completionBlock:(void (^)(Boolean isSuccess, id feature, NSError *error)) completionBlock;

@end

#endif

