#ifndef CKCoreNSBundle_h
#define CKCoreNSBundle_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//----------------------------------------------------------------------------------------------------
typedef NS_ENUM(NSInteger, CKCoreCodeSignState)
  {
  CKCoreCodeSignStateUnsigned = 1,
  CKCoreCodeSignStateSignatureValid,
  CKCoreCodeSignStateSignatureInvalid,
  CKCoreCodeSignStateSignatureNotVerifiable,
  CKCoreCodeSignStateSignatureUnsupported,
  CKCoreCodeSignStateError
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNSBundle

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSBundle (CodeSigningInfo)

- (BOOL)                 comesFromAppStore;
- (BOOL)                 isSandboxed;
- (CKCoreCodeSignState)  codeSignState;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSBundle (Localization)

- (NSString *) localizedString:(NSString *) withKey withDefault:(NSString *) withDefault;
- (NSString *) localizedString:(NSString *) withKey;

@end

#endif

