#ifndef CKCoreNSCoder_h
#define CKCoreNSCoder_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNSCoder

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSCoder (Values)

- (Boolean)    boolForKey:(NSString *) withKey withDefaultValue:(Boolean) withDefaultValue;
- (NSInteger)  intForKey:(NSString *) withKey withDefaultValue:(NSInteger) withDefaultValue;
- (CGFloat)    floatForKey:(NSString *) withKey withDefaultValue:(CGFloat) withDefaultValue;
- (NSString *) stringForKey:(NSString *) withKey withDefaultValue:(NSString *) withDefaultValue;
- (NSArray *)  arrayForKey:(NSString *) withKey withDefaultValue:(NSArray *) withDefaultValue;
- (NSDate *)   dateForKey:(NSString *) withKey withDefaultValue:(NSDate *) withDefaultValue;
- (NSData *)   dataForKey:(NSString *) withKey withDefaultValue:(NSData *) withDefaultValue;
- (NSURL *)    urlForKey:(NSString *) withKey withDefaultValue:(NSURL *) withDefaultValue;
- (NSImage *)  imageForKey:(NSString *) withKey withDefaultValue:(NSImage *) withDefaultValue;

@end

#endif

