#ifndef CKCoreNSWindow_h
#define CKCoreNSWindow_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNSWindow

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSWindow (Shape)

- (void) makeItRounded:(CGFloat) cornerRadius withBackColor:(NSColor *) backColor;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSWindow (Shake)

- (void) shakeWindow;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSWindow (Placement)

- (void) placeToMainScreenCenter;
- (void) placeToFirstScreenCenter;
- (void) placeToActiveScreenCenter;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSWindow (Color)

@property(nonatomic, retain) NSColor *backColor;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSWindow (Frame)

- (void)    resizeWindowWithContentSize:(NSSize) contentSize animated:(BOOL) animated;
- (CGFloat) titlebarHeight;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSWindow (Fade)

- (void) fadeIn:(void (^)(void)) completionBlock;
- (void) fadeOut:(void (^)(void)) completionBlock;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSWindow (Buttons)

- (void) enableMaximizeButton:(Boolean) withState;
- (void) enableCloseButton:(Boolean) withState;
- (void) enableMinimizeButton:(Boolean) withState;

@end

#endif

