#ifndef CKCoreNetworkMultipeer_h
#define CKCoreNetworkMultipeer_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNetworkMultipeer: NSObject

@property (nonatomic) id                  delegate;
@property (nonatomic) SEL                 onFileReceived;
@property (nonatomic) SEL                 onFileIncoming;
@property (nonatomic) SEL                 onInvitationReceived;
@property (nonatomic) SEL                 onStatusChanged;
@property (nonatomic) SEL                 onDataReceived;

- (id)      initWithPeerName:(NSString *) withPeerName;
- (void)    startAdvertising:(NSString *) withServiceType;
- (void)    stopAdvertising;
- (void)    startBrowsing:(NSString *) withServiceType;
- (void)    stopBrowsing;
- (Boolean) sendMessageToPeers:(NSString *) withMessage;

@end

#endif

