#ifndef CKCoreOpenWeatherMap_h
#define CKCoreOpenWeatherMap_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSInteger, CKCoreOpenWeatherMapUnits)
  {
  CKCoreOpenWeatherMapMetric,
  CKCoreOpenWeatherMapImperial,
  };
  
//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreOpenWeatherMap: NSObject

@property (nonatomic) NSString                    *APIKey;
@property (nonatomic) CKCoreOpenWeatherMapUnits    dataUnits;
@property (nonatomic) NSString                    *languageCode;

- (void) cleanUp;
- (void) getLocalWeather:(CGFloat) withLatitude withLongitude:(CGFloat) withLongitude completionBlock:(void (^)(Boolean isSuccess, NSDictionary *weatherData)) completionBlock;

@end

#endif 
