#ifndef CKCoreAudioFile_h
#define CKCoreAudioFile_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAudioFile: NSObject

@property (nonatomic) NSURL                         *audioFileUrl;
@property (nonatomic, readonly) NSTimeInterval       audioDuration;
@property (nonatomic, readonly) CGFloat              audioSampleRate;
@property (nonatomic, readonly) NSInteger            audioChannelCount;
@property (nonatomic, readonly) NSInteger            audioSamplesCount;
@property (nonatomic) AVAudioPCMBuffer              *audioBuffer;

- (float *) samplesForChannel:(NSInteger) withChannel;
- (Boolean) saveToUrl:(NSURL *) withUrl;
- (Boolean) saveToUrl:(NSURL *) withUrl settings:(NSDictionary *) settings;
- (void)    cleanUp;

@end

#endif

