#ifndef CKCoreBLEMyCharacteristic_h
#define CKCoreBLEMyCharacteristic_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

#import <CoreBluetooth/CoreBluetooth.h>

NS_ASSUME_NONNULL_BEGIN

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreBLEMyCharacteristic : NSObject

/**
 Characteristic's UUID
 */
@property (nonatomic, strong) CBUUID *uuid;
/**
 Characteristic's static value
 */
@property (nonatomic, strong) NSData *value;
/**
 Characteristic's descriptors
 */
@property (nonatomic, nullable, strong) NSArray<CBDescriptor *> *descriptor;
/**
 Characteristic's permissions
 */
@property (nonatomic, assign) CBAttributePermissions permission;
/**
 Characteristic's properties
 */
@property (nonatomic, assign) CBCharacteristicProperties property;

/**
 Get CBMutableCharacteristic object from built characteristic

 @return CBMutableCharacteristic instance
 */
- (CBMutableCharacteristic * ) object;

@end

NS_ASSUME_NONNULL_END

#endif

