#ifndef CKCoreCheckedBox_h
#define CKCoreCheckedBox_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSInteger, eCKCoreCheckedBoxStyle)
  {
  CKCoreCheckedBoxSquare,
  CKCoreCheckedBoxRound,
  CKCoreCheckedBoxRounded,
  };

typedef NS_ENUM(NSInteger, eCKCoreCheckedBoxAlignment)
  {
  CKCoreCheckedBoxAlignmentLeft,
  CKCoreCheckedBoxAlignmentRight,
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
IB_DESIGNABLE @interface CKCoreCheckedBox : NSView

@property (nonatomic) id                         delegate;
@property (nonatomic) SEL                        onCheckChanged;
@property (nonatomic) eCKCoreCheckedBoxStyle     style;
@property (nonatomic) eCKCoreCheckedBoxAlignment alignment;
@property (nonatomic) Boolean                    checked;
@property (nonatomic) Boolean                    enabled;
@property (nonatomic) Boolean                    animateTransition;
@property (nonatomic) NSColor                   *borderColor;
@property (nonatomic) NSColor                   *checkedColor;
@property (nonatomic) NSColor                   *textColor;
@property (nonatomic) CGFloat                    borderWidth;
@property (nonatomic) Boolean                    soundTransition;
@property (nonatomic) NSString                  *text;
@property (nonatomic) NSAttributedString        *attributedText;
@property (nonatomic) NSFont                    *font;
@property (nonatomic) NSInteger                  fontSize;

@end

#endif

