#ifndef CKCoreDropTargetView_h
#define CKCoreDropTargetView_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// PROTOCOL
//-------------------------------------------------------------------------------------------------------------------------
@protocol CKCoreDropTargetViewDelegate <NSObject>

@optional
- (void) onDropInProgress:(NSArray *) filesPath;
- (void) onDropError:(NSArray *) filesPath;
- (void) onDropComplete:(NSArray *) filesPath;
- (void) onDropAborted;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreDropTargetView: NSView

@property (nonatomic) Boolean                             acceptDrops;
@property (nonatomic) Boolean                             acceptSelection;
@property (nonatomic) id<CKCoreDropTargetViewDelegate>    delegate;
@property (nonatomic) NSArray                            *acceptedFileTypes;
@property (nonatomic) NSColor                            *colorIdle;
@property (nonatomic) NSColor                            *colorValidDrop;
@property (nonatomic) NSColor                            *colorInvalidDrop;

@end

#endif
