#ifndef CKCoreNSBezierPath_h
#define CKCoreNSBezierPath_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSInteger, BEZIERPATHCornerTypes)
  {
  BEZIERPATHTopLeftCorner     = 1,
  BEZIERPATHBottomLeftCorner  = 2,
  BEZIERPATHTopRightCorner    = 4,
  BEZIERPATHBottomRightCorner = 8
  };

typedef NS_ENUM(NSInteger, BEZIERPATHArrowDirection)
  {
  BEZIERPATHArrowLeftTop,
  BEZIERPATHArrowRightTop,
  BEZIERPATHArrowLeftBottom,
  BEZIERPATHArrowRightBottom,
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNSBezierPath

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSBezierPath (Path)

- (CGPathRef) CGPathReference;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSBezierPath (Shape)

+ (NSBezierPath *) bezierPathWithRoundedRect:(NSRect) aRect cornerRadius:(float) radius;
+ (NSBezierPath *) bezierPathWithRoundedRect:(NSRect) aRect cornerRadius:(float) radius inCorners:(BEZIERPATHCornerTypes) corners;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSBezierPath (MessageBubble)

+ (NSBezierPath *) createMessageBubble:(NSRect) frame arrowDirection:(BEZIERPATHArrowDirection) arrowDirection borderWidth:(CGFloat) borderWidth borderColor:(NSColor *) borderColor backgroundColor:(NSColor *) backgroundColor flipVertical:(Boolean) flipVertical;

@end

#endif

