#ifndef CKCoreNetworkCurl_h
#define CKCoreNetworkCurl_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNetworkCurl: NSObject

+ (void) postStringGetString:(NSURL *) toUrl withString:(NSString *) withString withHTTPHeaders:(NSDictionary *) withHTTPHeaders completionBlock:(void (^)(Boolean isSuccess, NSString *output, NSError *error)) completionBlock;
+ (void) postStringGetData:(NSURL *) toUrl withString:(NSString *) withString withHTTPHeaders:(NSDictionary *) withHTTPHeaders completionBlock:(void (^)(Boolean isSuccess, NSData *output, NSError *error)) completionBlock;
+ (void) postStringGetArray:(NSURL *) toUrl withString:(NSString *) withString withHTTPHeaders:(NSDictionary *) withHTTPHeaders completionBlock:(void (^)(Boolean isSuccess, NSArray *output, NSError *error)) completionBlock;
+ (void) postStringGetDictionary:(NSURL *) toUrl withString:(NSString *) withString withHTTPHeaders:(NSDictionary *) withHTTPHeaders completionBlock:(void (^)(Boolean isSuccess, NSDictionary *output, NSError *error)) completionBlock;
+ (void) postStringGetFile:(NSURL *) toUrl withString:(NSString *) withString withHTTPHeaders:(NSDictionary *) withHTTPHeaders saveTo:(NSURL *) saveTo completionBlock:(void (^)(Boolean isSuccess, NSError *error)) completionBlock;
+ (void) postDataGetData:(NSURL *) toUrl withData:(NSData *) withData withHTTPHeaders:(NSDictionary *) withHTTPHeaders completionBlock:(void (^)(Boolean isSuccess, NSData *output, NSError *error)) completionBlock;
+ (void) postDictionaryGetData:(NSURL *) toUrl withDictionary:(NSDictionary *) withDictionary withHTTPHeaders:(NSDictionary *) withHTTPHeaders completionBlock:(void (^)(Boolean isSuccess, NSData *output, NSError *error)) completionBlock;
+ (void) postDataGetDictionary:(NSURL *) toUrl withData:(NSData *) withData withHTTPHeaders:(NSDictionary *) withHTTPHeaders completionBlock:(void (^)(Boolean isSuccess, NSDictionary *output, NSError *error)) completionBlock;

@end

#endif

