#ifndef CKCoreStandardButton_h
#define CKCoreStandardButton_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSInteger, eCKCoreStandardButtonState)
  {
  CKCoreStandardButtonStateNormal,
  CKCoreStandardButtonStateHovered,
  CKCoreStandardButtonStatePushed,
  };

typedef NS_ENUM(NSInteger, eCKCoreStandardButtonPushMode)
  {
  CKCoreStandardButtonPushModeNormal,
  CKCoreStandardButtonPushModeONOFF,
  };

typedef NS_ENUM(NSInteger, eCKCoreStandardButtonAlignment)
  {
  CKCoreStandardButtonAlignmentLeft,
  CKCoreStandardButtonAlignmentRight,
  };

//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreStandardButton: NSView

@property (nonatomic, assign) eCKCoreStandardButtonPushMode                  buttonMode;
@property (nonatomic, assign) eCKCoreStandardButtonState                     buttonState;

@property (nonatomic) NSArray <NSColor *>                  *gradientColors;
@property (nonatomic) NSArray <NSNumber *>                 *gradientLocations;
@property (nonatomic) NSColor                              *borderColor;
@property (nonatomic) Boolean                               borderGlow;
@property (nonatomic) NSString                             *buttonText;
@property (nonatomic) NSString                             *buttonTextOn;
@property (nonatomic) NSInteger                             buttonTextFontSize;
@property (nonatomic) Boolean                               enabled;
@property (nonatomic) Boolean                               disableIfNoNetwork;
@property (nonatomic) Boolean                               disableOnClick;
@property (nonatomic) Boolean                               offIfDisabled;
@property (nonatomic) Boolean                               on;
@property (nonatomic) NSImage                              *buttonImage;
@property (nonatomic) NSImage                              *buttonImageOn;
@property (nonatomic) NSDictionary                         *behaviorScheme;
@property (nonatomic) Boolean                               enableExpandIcon;
@property (nonatomic) Boolean                               rotate;

@property (nonatomic) id                                    delegate;
@property (nonatomic) SEL                                   onButtonClick;
@property (nonatomic) SEL                                   onButtonDown;
@property (nonatomic) SEL                                   onButtonEntered;
@property (nonatomic) SEL                                   onButtonExited;
@property (nonatomic) SEL                                   onButtonSwitched;

- (void) setTooltip:(NSString *) value;
- (void) cleanUp;
- (void) click;

@end

#endif

