#ifndef CKCoreView_h
#define CKCoreView_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreView: NSView

@property (nonatomic) id                                    delegate;
@property (nonatomic) SEL                                   onMouseRightClick;
@property (nonatomic) SEL                                   onMouseDown;
@property (nonatomic) SEL                                   onMouseUp;
@property (nonatomic) SEL                                   onScrollWheel;
@property (getter = isFlipped, nonatomic) BOOL              flipped;
@property (nonatomic) BOOL                                  clipping;

@property (nonatomic) CGFloat                               gradientAngle;
@property (nonatomic) NSArray <NSColor *>                  *gradientColors;
@property (nonatomic) NSArray <NSNumber *>                 *gradientLocations;

@property (nonatomic) CGFloat                               borderWidth;
@property (nonatomic) NSColor                              *borderColor;
@property (nonatomic) CGFloat                               cornerRadius;
@property (nonatomic) NSArray <NSNumber *>                 *cornersRadius;

@property (nonatomic) NSColor                              *backgroundColor;
@property (nonatomic) NSImage                              *backgroundImage;
@property (nonatomic) NSColor                              *backgroundImageTint;
@property (nonatomic) CGFloat                               backgroundImageScaleFactor;

@property (nonatomic) NSColor                              *backgroundTextColor;
@property (nonatomic) NSFont                               *backgroundTextFont;
@property (nonatomic) NSString                             *backgroundText;
@property (nonatomic) NSTextAlignment                       backgroundTextAlignment;

@property (nonatomic) id                                    userData;

@end

#endif
