#import <Foundation/Foundation.h>
#import <Cocoa/Cocoa.h>

//-------------------------------------------------------------------------------------------------------------------------
// DEFINES
//-------------------------------------------------------------------------------------------------------------------------
#define MAINTHREADBLOCKSTART        dispatch_async(dispatch_get_main_queue(), ^{
#define MAINTHREADBLOCKEND          });
#define BACKTHREADBLOCKSTART        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
#define BACKTHREADBLOCKEND          });
#define AUTORELEASEPOOLSTART        @autoreleasepool {
#define AUTORELEASEPOOLEND          }
#define BACKTHREADHIGHBLOCKSTART    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_HIGH, 0), ^{
#define BACKTHREADHIGHBLOCKEND      });
#define BACKTHREADMAINQUEUESTART    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
#define BACKTHREADMAINQUEUEEND      }];
#define MAINTHREADLOOP              [[NSRunLoop mainRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:.1]];
#define CURRENTTHREADLOOP           [[NSRunLoop currentRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:.1]];

#define RUNLOOPCLEAN \
  if ([NSRunLoop currentRunLoop] != [NSRunLoop mainRunLoop]) [[NSRunLoop currentRunLoop] runUntilDate:[NSDate date]];

#if !defined(StringOrEmpty)
  #define stringOrEmpty(A)  ({ __typeof__(A) __a = (A); __a ? __a : @""; })
#endif

#if !defined(degreesToRadians)
  #define degreesToRadians( degrees ) (degrees / 180.0 * M_PI)
#endif

#if !defined(radiansToDegrees)
  #define radiansToDegrees( radians ) (radians * 180.0 / M_PI)
#endif

#define SYNCHRONIZEGET(_Type, _NameGet) \
- (_Type) _NameGet { @synchronized(lock) { return self->_NameGet; } }

#define SYNCHRONIZE(_Type, _NameGet, _NameSet) \
- (_Type) _NameGet { @synchronized(lock) { return self->_NameGet; } } \
- (void) _NameSet:(_Type) value { @synchronized(lock) { self->_NameGet = value; } }

#define SYNCHRONIZESET(_Type, _NameGet, _NameSet) \
- (void) _NameSet:(_Type) value { @synchronized(lock) { self->_NameGet = value; } }

#if !defined(StringOrEmpty)
  #define StringOrEmpty(A)  ({ __typeof__(A) __a = (A); __a ? __a : @""; })
#endif

#if !defined(isEven)
  #define isEven(A)  (((NSInteger) A % 2) == 0)
  #define isOdd(A)   (((NSInteger) A % 2) != 0)
#endif

//-------------------------------------------------------------------------------------------------------------------------
// COMMON iOS / macOS
//-------------------------------------------------------------------------------------------------------------------------

//----- Framework -----
#include <CodKits_macOS/CKCoreFramework.h>

//----- NSString -----
#include <CodKits_macOS/CKCoreNSString.h>

//----- NSMutableString -----
#include <CodKits_macOS/CKCoreNSMutableString.h>

//----- NSMutableArray -----
#include <CodKits_macOS/CKCoreNSMutableArray.h>

//----- NSDictionary -----
#include <CodKits_macOS/CKCoreNSDictionary.h>

//----- NSData -----
#include <CodKits_macOS/CKCoreNSData.h>

//----- NSDate -----
#include <CodKits_macOS/CKCoreNSDate.h>

//----- NSArray -----
#include <CodKits_macOS/CKCoreNSArray.h>

//----- NSValue -----
#include <CodKits_macOS/CKCoreNSValue.h>

//----- NSCoder -----
#include <CodKits_macOS/CKCoreNSCoder.h>

//----- NSObject -----
#include <CodKits_macOS/CKCoreNSObject.h>

//----- NSCalendar -----
#include <CodKits_macOS/CKCoreNSCalendar.h>

//----- Camera -----
#include <CodKits_macOS/CKCoreQRCodeCapture.h>

//----- NSCountedSet -----
#include <CodKits_macOS/CKCoreNSCountedSet.h>

//----- Credit Card -----
#include <CodKits_macOS/CKCoreCreditCardValidator.h>

//----- NSURL -----
#include <CodKits_macOS/CKCoreNSURL.h>

//----- NSColor -----
#include <CodKits_macOS/CKCoreNSColor.h>
#include <CodKits_macOS/CKCoreColorScheme.h>

//----- Threading -----
#include <CodKits_macOS/CKCoreParallelProcessing.h>

//----- Notifications -----
#include <CodKits_macOS/CKCoreNotifications.h>

//----- Random -----
#include <CodKits_macOS/CKCoreRandom.h>

//----- Cryptography -----
#include <CodKits_macOS/CKCoreCryptography.h>

//----- Security -----
#include <CodKits_macOS/CKCoreKeychain.h>
#include <CodKits_macOS/CKCoreKeychainQuery.h>
#include <CodKits_macOS/CKCoreCredentialsStorage.h>
#include <CodKits_macOS/CKCorePasswordGenerator.h>
#include <CodKits_macOS/CKCorePasswordStrengthEvaluator.h>

//----- File System -----
#include <CodKits_macOS/CKCoreFileSystem.h>
#include <CodKits_macOS/CKCoreNumpy2DArray.h>
#include <CodKits_macOS/CKCoreCSVFile.h>

//----- Image -----
#include <CodKits_macOS/CKCoreCIFilters.h>
#include <CodKits_macOS/CKCoreImageVision.h>

//----- NSImageView -----
#include <CodKits_macOS/CKCoreNSImageView.h>

//----- CGObjects -----
#include <CodKits_macOS/CKCoreCGUtilities.h>

//----- Maths -----
#include <CodKits_macOS/CKCoreMaths.h>

//----- vDSP -----
#include <CodKits_macOS/CKCorevDSP.h>

//----- Date Time -----
#include <CodKits_macOS/CKCoreDateTime.h>

//----- Number -----
#include <CodKits_macOS/CKCoreNumber.h>

//----- Resources -----
#include <CodKits_macOS/CKCoreResources.h>
#include <CodKits_macOS/CKCoreCountries.h>

//----- Timer -----
#include <CodKits_macOS/CKCoreTimer.h>
#include <CodKits_macOS/CKCoreTaskScheduler.h>
#include <CodKits_macOS/CKCoreExecutionTime.h>
#include <CodKits_macOS/CKCoreHighPrecisionTimer.h>

//----- Networking -----
#include <CodKits_macOS/CKCoreUrlDownloader.h>
#include <CodKits_macOS/CKCoreFileUploader.h>
#include <CodKits_macOS/CKCoreFileDownloader.h>
#include <CodKits_macOS/CKCoreNetworkCurl.h>
#include <CodKits_macOS/CKCoreNetworkMultipeer.h>

//----- Bluetooth BLE -----
#include <CodKits_macOS/CKCoreBLECentral.h>
#include <CodKits_macOS/CKCoreBLEPeripheral.h>
#include <CodKits_macOS/CKCoreBLEMyCharacteristic.h>

//----- AVObjects -----
#include <CodKits_macOS/CKCoreAVPlayerItem.h>
#include <CodKits_macOS/CKCoreAVAsset.h>
#include <CodKits_macOS/CKCoreAVAssetTrack.h>
#include <CodKits_macOS/CKCoreAVPlayer.h>
#include <CodKits_macOS/CKCoreAVPlayerLayer.h>

//----- CAObjects -----
#include <CodKits_macOS/CKCoreCALayer.h>

//----- Local Settings Storage -----
#include <CodKits_macOS/CKCoreSettingsStorage.h>

//----- TouchID -----
#include <CodKits_macOS/CKCoreTouchID.h>

//----- NSView -----
#include <CodKits_macOS/CKCoreNSView.h>
#include <CodKits_macOS/CKCoreAnimatedBorderView.h>
#include <CodKits_macOS/CKCoreVideoShowView.h>

//----- NSAttributedString -----
#include <CodKits_macOS/CKCoreNSAttributedString.h>

//----- Audio -----
#include <CodKits_macOS/CKCoreQuickSoundPlay.h>
#include <CodKits_macOS/CKCoreSoundPlay.h>
#include <CodKits_macOS/CKCoreSoundsPlay.h>
#include <CodKits_macOS/CKCoreAudioFile.h>
#include <CodKits_macOS/CKCoreAudioEnergyMap.h>
#include <CodKits_macOS/CKCoreAudioRMSLevels.h>
#include <CodKits_macOS/CKCoreAudioTools.h>
#include <CodKits_macOS/CKCoreAudioSpectrumView.h>

//----- InApp Purchase -----
#include <CodKits_macOS/CKCoreInAppPurchase.h>

//----- Video -----
#include <CodKits_macOS/CKCoreVideoTools.h>

//----- NSImage -----
#include <CodKits_macOS/CKCoreQRCodeGenerator.h>

//----- NSOperationQueue -----
#include <CodKits_macOS/CKCoreNSOperationQueue.h>

//----- Wrappers -----
#include <CodKits_macOS/CKCoreElevenLabs.h>
#include <CodKits_macOS/CKCoreOpenAI.h>
#include <CodKits_macOS/CKCoreCoinbase.h>
#include <CodKits_macOS/CKCoreDeepgram.h>
#include <CodKits_macOS/CKCoreAnthropic.h>
#include <CodKits_macOS/CKCoreOpenWeatherMap.h>

//----- Observers -----
#include <CodKits_macOS/CKCoreObserver.h>
#include <CodKits_macOS/CKCoreObserverDeallocator.h>
#include <CodKits_macOS/NSObject+Observing.h>

//-------------------------------------------------------------------------------------------------------------------------
// SPECIFIC macOS
//-------------------------------------------------------------------------------------------------------------------------

//----- Bridge Header -----
#include <CodKits_macOS/CodKits_macOS-Bridging-Header.h>

//----- System Info -----
#include <CodKits_macOS/CKCoreSystemInfo.h>

//----- Networking -----
#include <CodKits_macOS/CKCoreNetwork.h>

//----- NSScreen -----
#include <CodKits_macOS/CKCoreNSScreen.h>

//----- NSImage -----
#include <CodKits_macOS/CKCoreNSImage.h>

//----- Finder -----
#include <CodKits_macOS/CKCoreFinder.h>

//----- Dock Icon -----
#include <CodKits_macOS/CKCoreDockIcon.h>

//----- Animation -----
#include <CodKits_macOS/CKCoreViewAnimation.h>

//----- NSBundle -----
#include <CodKits_macOS/CKCoreNSBundle.h>

//----- Camera -----
#include <CodKits_macOS/CKCoreCamera.h>
#include <CodKits_macOS/CKCoreCameraRecord.h>
#include <CodKits_macOS/CKCoreCameraSnapshot.h>

//----- Security -----
#include <CodKits_macOS/CKCoreLocalCredentials.h>

//----- NSFont -----
#include <CodKits_macOS/CKCoreNSFont.h>

//----- NSWindow -----
#include <CodKits_macOS/CKCoreNSWindow.h>

//----- NSBezierPath -----
#include <CodKits_macOS/CKCoreNSBezierPath.h>

//----- Custom NSView -----
#include <CodKits_macOS/CKCoreView.h>
#include <CodKits_macOS/CKCoreDropTargetView.h>

//----- NSMenu -----
#include <CodKits_macOS/CKCoreNSMenuItem.h>
#include <CodKits_macOS/CKCoreNSMenu.h>

//----- NSOpenPanel -----
#import <CodKits_macOS/CKCoreNSOpenPanel.h>

//----- NSTextField -----
#import <CodKits_macOS/CKCoreNSTextField.h>
#import <CodKits_macOS/CKCoreClearTextEntry.h>
#import <CodKits_macOS/CKCoreHiddenTextEntry.h>
#import <CodKits_macOS/CKCoreAutoCompleteTextField.h>

//----- NSButton -----
#import <CodKits_macOS/CKCoreStandardButton.h>

//----- NSLabel -----
#import <CodKits_macOS/CKCoreLabel.h>

//----- Widgets -----
#import <CodKits_macOS/CKCoreLinearProgress.h>
#import <CodKits_macOS/CKCoreCheckedBox.h>

//----- NSMenu -----
#include <CodKits_macOS/CKCorePasteBoard.h>
